<?php

require __DIR__ . '/vendor/autoload.php';

use Telegram\Bot\Api;
use Intervention\Image\ImageManagerStatic as Image;

$telegram = new Api('6862637503:AAEvvffUYcLWpnY6FrEkXjpFQdii3FHa7xg');

// دستگیره برای دستور /start
$telegram->addCommand(new class extends \Telegram\Bot\Commands\Command {
    protected $name = 'start';
    protected $description = 'شروع ربات';

    public function handle($arguments)
    {
        $this->replyWithMessage(['text' => 'سلام! تصویری را بفرست تا آن را به ASCII Art تبدیل کنم.']);
    }
});

// دریافت به‌روزرسانی‌ها
$update = $telegram->getWebhookUpdates();
$message = $update->getMessage();

if ($message && $message->has('photo')) {
    $photo = $message->getPhoto()[count($message->getPhoto()) - 1];
    $file = $telegram->getFile(['file_id' => $photo->getFileId()]);

    $filePath = $file->getFilePath();
    $fileUrl = "https://api.telegram.org/file/bot" . $telegram->getAccessToken() . "/" . $filePath;

    // دانلود تصویر
    $imageData = file_get_contents($fileUrl);
    file_put_contents('image.jpg', $imageData);

    // تبدیل تصویر به ASCII Art
    $asciiArt = convertImageToAscii('image.jpg');

    // ارسال نتیجه به کاربر
    $telegram->sendMessage([
        'chat_id' => $message->getChat()->getId(),
        'text' => "```\n" . $asciiArt . "\n```",
        'parse_mode' => 'Markdown'
    ]);
}

function convertImageToAscii($imagePath)
{
    $img = Image::make($imagePath)->resize(80, 60);
    $asciiArt = '';
    $chars = ['@', '%', '#', '*', '+', '=', '-', ':', '.', ' '];

    for ($y = 0; $y < $img->height(); $y++) {
        for ($x = 0; $x < $img->width(); $x++) {
            $pixel = $img->pickColor($x, $y);
            $gray = (int)(($pixel[0] + $pixel[1] + $pixel[2]) / 3);
            $char = $chars[(int)(($gray / 255) * (count($chars) - 1))];
            $asciiArt .= $char;
        }
        $asciiArt .= "\n";
    }

    return $asciiArt;
}
